{$G+}
unit Sp97Btn;
interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons;

type
  TSp97Btn = class(TSpeedButton)
  private
      { Private declarations }
    FModifiedGlyph: Boolean;
    FKind: TBitBtnKind;
    FModalResult: TModalResult;
    procedure SetKind(Value: TBitBtnKind);
    function GetKind: TBitBtnKind;
  protected
    { Protected declarations }

  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published declarations }
    property Kind: TBitBtnKind read GetKind write SetKind default bkCustom;
    property ModalResult: TModalResult read FModalResult write FModalResult default 0;
  end;

procedure Register;

implementation

uses Consts, SysUtils;
{$R BUTTONS97.RES}

var
//(bkCustom, bkOK, bkCancel, bkHelp, bkYes, bkNo, bkClose, bkAbort, bkRetry, bkIgnore, bkAll);

 BitBtnResNames: array[TBitBtnKind] of PChar = (
    nil, 'TJOK', 'TJCANCEL', 'TJHELP', 'TJYES', 'TJNO', 'TJCLOSE','TJABORT',
    'TJRETRY', 'TJIGNORE', 'TJALL');
 ButtonNames: array[TBitBtnKind] of string = ('', 'OK', 'Cancel', 'Help',
             'Yes', 'No','Close', 'Abort', 'Retry', 'Ignore','All');
  BitBtnModalResults: array[TBitBtnKind] of TModalResult = (
    0, mrOk, mrCancel, 0, mrYes, mrNo, 0, mrAbort, mrRetry, mrIgnore, mrAll);
  BitBtnGlyphs: array[TBitBtnKind] of TBitmap;


procedure Register;
begin
  RegisterComponents('Standard', [TSp97Btn]);
end;

constructor TSp97Btn.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ParentFont := false;
  flat := true;
  Spacing := 0;
  Width := 75;
  kind := bkOk;
 end;

destructor TSp97Btn.Destroy;
begin
   inherited Destroy;
end;

function GetBitBtnGlyph(Kind: TBitBtnKind): TBitmap;
begin
  if BitBtnGlyphs[Kind] = nil then
  begin
    BitBtnGlyphs[Kind] := TBitmap.Create;
    BitBtnGlyphs[Kind].LoadFromResourceName(HInstance, BitBtnResNames[Kind]);
  end;
  Result := BitBtnGlyphs[Kind];
end;

procedure TSp97Btn.SetKind(Value: TBitBtnKind);
begin
  if Value <> FKind then
  begin
    if Value <> bkCustom then
    begin
      if ((csLoading in ComponentState) and (Caption = '')) or
        (not (csLoading in ComponentState)) then
      begin
        Caption := ButtonNames[Value];
      end;
      ModalResult := BitBtnModalResults[Value];
      Glyph := GetBitBtnGlyph(Value);
      NumGlyphs := 2;
      FModifiedGlyph := False;
    end;
    FKind := Value;
    Invalidate;
  end;
end;

function TSp97Btn.GetKind: TBitBtnKind;
begin
   Result := FKind;
end;


end.
